SystemOrganization addCategory: #SwazooSpike!

SwazooResource subclass: #S2JWebApp
	instanceVariableNames: ''
	classVariableNames: 'globalResponseId isServing responseContent sessions'
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:47'!
applicationPath

	^ '/app'.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/7/2010 18:05'!
defaultMillisecondsToWait

	^ 100.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/2/2010 11:27'!
defaultPort

	^ 8887! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/6/2010 12:47'!
defaultResponseId

	^ 0.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/6/2010 13:51'!
defaultSuccessResponse

	^ 'success'! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/1/2010 22:44'!
globalResponseId
	^ globalResponseId! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/1/2010 22:44'!
globalResponseId: anObject
	globalResponseId := anObject! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:18'!
increaseResponseId

	self globalResponseId: self globalResponseId + 1.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:47'!
inputPath

	^ '/put'.! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
isInstalled

	^ self site notNil.! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/7/2010 10:33'!
isServing
	^ isServing! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/7/2010 10:33'!
isServing: anObject
	isServing := anObject! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/6/2010 12:44'!
prepareSite

	| site |
	site := SwazooSite newNamed: self siteName.
	site
		host: '*'
		ip: '*'
		port: self defaultPort;
		addResource: (self uriPattern: '/').
	self sessions: Dictionary new.
	^ site! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/2/2010 11:28'!
removeSite

	SwazooServer singleton removeSite: self site.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/6/2010 15:12'!
replacementDictionary

	^ Dictionary new
		at: '<' put: '%3C';
		at: '>' put: '%3E';
		yourself.! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:18'!
resetContent

	self
		globalResponseId: 0;
		responseContent: nil.
	self allInstances do: [ : each  | each localResponseId: 0 ]. ! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'SW 12/1/2010 16:28'!
responseContent
	^responseContent
! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'SW 12/1/2010 16:15'!
responseContent: anObject
	responseContent := anObject! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/6/2010 11:41'!
sessions
	^ sessions! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/6/2010 11:41'!
sessions: anObject
	sessions := anObject! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
site

	^ SwazooServer singleton siteNamed: self siteName.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 21:39'!
siteName

	^ 'S2JWebApp'.! !

!S2JWebApp class methodsFor: 'launch' stamp: 'HK 12/7/2010 10:35'!
startWebApp

	self isInstalled ifFalse: [ self prepareSite ].
	self isServing: true.
	self site start.
! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/7/2010 16:49'!
toggleIsServing

	self isServing: self isServing not! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:48'!
updateResponseContentWith: content

	self responseContent: content.
	self increaseResponseId.! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'ag 12/9/2010 17:30'!
updateResponseContentWithSqueakCode: content

	| jsCode |
	[ jsCode := S2JPrinter convertStatements: content ]
		on: Exception do: [ :err | jsCode := '"Could not parse squeak-code: ', Character cr asString, content, Character cr asString, 'Error was: ', err asString, '"' ].
	self updateResponseContentWith: jsCode.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:45'!
xmlPath

	^ '/xml'.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/6/2010 13:39'!
answerContent: data withType: aString

	| response |
	response := HTTPResponse ok.
	^ response
		contentType: aString;
		entity: data;
		yourself.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 11:41'!
answerCreated

	^ HTTPResponse new code: 201.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 11:53'!
answerForbidden

	^ HTTPResponse forbidden.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 11:53'!
answerNoContent

	^ HTTPResponse new code: 204.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 13:42'!
answerTo: aRequest 

	| resource response |
		
	resource := self identifierOf: aRequest.
	response := self handleRequest: aRequest for: resource.
	
	(self hasSession: aRequest) ifFalse: [ self startSessionWith: response.].
	
	^ response.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 13:42'!
answerWebsite

	^ self
		answerContent: self renderWebsite
		withType: 'text/html'.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 13:45'!
answerXmlDataTo: aRequest

	self increaseLocalResponseIdFor: aRequest.
	^ self
		answerContent: (self wrapUpAsXml: self class responseContent)
		withType: 'text/xml'.! !

!S2JWebApp methodsFor: 'synchronization' stamp: 'HK 12/6/2010 13:47'!
clientIsBehindWith: aRequest

	^ self class globalResponseId > (self localResponseIdFor: aRequest).! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/7/2010 18:04'!
cssData 

	^ 'body {
		font-family: Verdana;
		margin: 0px;
		padding: 0px;
	}
	
	#container {
		width: 80%;
		margin: 0px auto;
	}
	
	textarea {
		width: 100%;
		background-color: #F9F7ED;
		border: 1px solid #4096EE;
	}
	
	table {
		width: 100%;
	}
	
	th {
		text-align: left;
		width: 45%;
	}

	tr th:first-child {
		width: 10%;	
	}
	
	.red {
		background-color: #D15600;
	}
	
	.yellow {
		background-color: #FFFF88;
	}
	
	.green {
		background-color: #6BBA70;
	}'.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 11:40'!
handleInputOf: aRequest

	| content |
	content := self postDataOf: aRequest.
	content ifNotNil:
		[self increaseLocalResponseIdFor: aRequest.
		self class updateResponseContentWith: content].
	^ self answerCreated.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 13:43'!
handleRequest: aRequest for: aResource

	aResource = self class applicationPath ifTrue: [ ^ self answerWebsite ].
	aResource = self class xmlPath ifTrue: [ ^ self handleXmlRequest: aRequest ].
	aResource = self class inputPath ifTrue: [ ^ self handleInputOf: aRequest ].
	^ self redirectToHome.
	
	! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 14:08'!
handleXmlRequest: aRequest

	^ (self hasNewDataFor: aRequest)
		ifTrue: [ self answerXmlDataTo: aRequest ]
		ifFalse:
			[ self suspendRequestAndExecute:
				[ ^ self handleXmlRequest: aRequest ]].! !

!S2JWebApp methodsFor: 'synchronization' stamp: 'HK 12/6/2010 13:47'!
hasNewDataFor: aRequest

	self class responseContent ifNil: [ ^ false ].
	(self hasSession: aRequest) ifFalse: [ ^ true ].
	^ self clientIsBehindWith: aRequest.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/6/2010 14:23'!
hasSession: aRequest

	^ aRequest cookie notNil and: [ self class sessions includesKey: (aRequest cookie asNumber) ].! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/1/2010 22:00'!
htmlDocumentType

	^ '<!!DOCTYPE html>'.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'SW 12/1/2010 16:08'!
identifierOf: aRequest

	^ aRequest requestLine requestURI identifier.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/7/2010 10:46'!
increaseLocalResponseIdFor: aRequest

	self class sessions at: (aRequest cookie asNumber) put: self class globalResponseId.
	Transcript show: 'Client #', aRequest cookie, ' is now at ', self class globalResponseId asString; cr.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'LT 12/22/2010 16:11:32.979'!
javascriptCanvasLibraryCode

	^ '
/**
 * A drawing library for the HTML 5 canvas element that follows the Graphics library in the JDK.
 * @author Tony Okorodudu
 */
(function () {
    ctk = {
        /**
        * Constructs a new Rectangle whose upper-left corner is specified as (x,y) and whose width
        * and height are specified by the arguments of the same name
        * @param {Number} x  the specified X coordinate
        * @param {Number} y  the specified Y coordinate
        * @param {Number} width  the width of the Rectangle
        * @param {Number} height  the height of the Rectangle
        */
        Rectangle: function (x, y, width, height) {
            this.x = x || 0;
            this.y = y || 0;
            this.width = width || 0;
            this.height = height || 0;

            /**
            * Create a clone of this rectangle
            * @returns {ctk.Rectangle}  A clone of this rectangle
            */
            this.clone = function () {
                return new ctk.Rectangle(this.x, this.y, this.width, this.height);
            };

            /**
            * Set the location for the rectangle
            * @param {Number} x  the specified X coordinate
            * @param {Number} y  the specified Y coordinate
            */
            this.setLocation = function (x, y) {
                this.x = x;
                this.y = y;
            };

            /**
            * Check if this rectangle contains the given x/y coordinate
            * @param {Number} x  the specified X coordinate
            * @param {Number} y  the specified Y coordinate
            * @returns {Boolean} true if the rectangle contains the coordinate and false if otherwise
            */
            this.containsPoint = function (x, y) {
                return ((this.x <= x && this.x + this.width >= x) && (this.y <= y && this.y + this.height >= y));
            };

            /**
            * Checks whether this Rectangle entirely contains the Rectangle  at the specified location with the specified dimensions
            * @param {Number} x  the specified X coordinate
            * @param {Number} y  the specified Y coordinate
            * @param {Number} width  the width of the rectangle
            * @param {Number} height  the height of the rectangle
            * @returns {Boolean} true if the rectangle specified is entirely enclosed inside this rectangle; false otherwise.
            */
            this.containsBounds = function (x, y, width, height) {
                return ((((this.x <= x) && (x + width <= this.x + this.width)) && (this.y <= y)) && (y + height <= this.y + this.height));
            };
        },
        
        
        /**
        * Construct a new graphics object.
        * @param {HTMLElement} canvas  A reference to the canvas DOM element
        */
        FontMetrics: function (context) {
            /**
            * Returns the total width for showing the specified String in this Font
            * @param {String} str  the String to be measured
            * @returns {Number} the width of the specified String
            */
            this.stringWidth = function (str) {
                return context.measureText ? context.measureText(str).width : 0;
            };
        },


        /**
        * Construct a new graphics object.
        * @param {HTMLElement} canvas  A reference to the canvas DOM element
        */
        Graphics: function (canvas) {
            var _canvas = (typeof (canvas) === ''string'') ? document.getElementById(canvas) : canvas;
            var _context = _canvas.getContext("2d");
            var _origin = new ctk.Rectangle(0, 0);
            var _fontMetrics = new ctk.FontMetrics(_context);


            /**
            * Get the underlying canvas
            * @returns {HTMLElement}  this object''s underlying canvas
            */
            this.getCanvas = function () {
                return _canvas;
            };

            /**
            * Get the graphic''s context
            * @returns {Context}  the font metrics of this graphics context''s current font
            */
            this.getContext = function () {
                return _context;
            };

            /**
            *  Gets the font metrics of the current font
            * @returns {ctk.FontMetrics}  this object''s graphic''s context
            */
            this.getFontMetrics = function () {
                return _fontMetrics;
            };

            /**
            * Get the width of the canvas
            * @returns {Number}  The width of the canvas
            */
            this.getWidth = function () {
                return _canvas.width;
            };

            /**
            * Get the height of the canvas
            * @returns {Number}  The height of the canvas
            */
            this.getHeight = function () {
                return _canvas.height;
            };

            /**
            * Creates a new Graphics object based on this Graphics object, but with a new translation and clip area
            * @param {Number} x  the x coordinate
            * @param {Number} y  the y coordinate
            * @param {Number} width  the width of the clipping rectangle
            * @param {Number} height  the height of the clipping rectangle
            * @returns {ctk.Graphics}  a new graphics context
            */
            this.create = function (x, y, width, height) {
                var copy = new ctk.Graphics(_canvas);

                if (x !!== undefined && x !!== null && y !!== undefined && y !!== null) {
                    copy.translate(x, y);
                }

                return copy;
            };

            /**
            * Sets this graphics context''s current color to the specified color.
            * @param {String} color  the new rendering color
            */
            this.setColor = function (color) {
                _context.fillStyle = color;
            };

            /**
            * Gets this graphics context''s current color.
            * @returns {String}  this graphics context''s current color
            */
            this.getColor = function () {
                return _context.fillStyle;
            };

            /**
            * Sets this graphics context''s current stroke color to the specified color.
            * @param {String} color  the new rendering stroke color
            */
            this.setStrokeColor = function (color) {
                _context.strokeStyle = color;
            };

            /**
            * Gets this graphics context''s current stroke color.
            * @returns {String}  this graphics context''s current stroke color
            */
            this.getStrokeColor = function () {
                return _context.strokeStyle;
            };

            /**
            * Sets this graphics context''s line width.
            * @param {Number} width  the line width
            */
            this.setLineWidth = function (width) {
                _context.lineWidth = width;
            };

            /**
            * Gets this graphics context''s line width.
            * @returns {Number}  this graphics context''s current line width
            */
            this.getLineWidth = function () {
                return _context.lineWidth;
            };

            function createCirclePath(x, y, radius) {
                _context.beginPath();
                _context.arc(_origin.x + x + radius, _origin.y + y + radius, radius, 0, Math.PI * 2, true);
                _context.closePath();
            }

            function createEllipsePath(x, y, width, height) {
                if (width === height) {
                    createCirclePath(x, y, width / 2);
                } else {
                    var w = width / 2;
                    var h = height / 2;
                    var C = 0.5522847498307933;
                    var c_x = C * w;
                    var c_y = C * h;
                    x = _origin.x + x + w;
                    y = _origin.y + y + h;
                    _context.beginPath();
                    _context.moveTo(x + w, y);
                    _context.bezierCurveTo(x + w, y - c_y, x + c_x, y - h, x, y - h);
                    _context.bezierCurveTo(x - c_x, y - h, x - w, y - c_y, x - w, y);
                    _context.bezierCurveTo(x - w, y + c_y, x - c_x, y + h, x, y + h);
                    _context.bezierCurveTo(x + c_x, y + h, x + w, y + c_y, x + w, y);
                    _context.closePath();
                }
            }

            function createPolygonPath(xPoints, yPoints, nPoints) {
                _context.beginPath();

                if ((xPoints !!== null) && (yPoints !!== null)) {
                    var numberOfPoints = Math.min(nPoints, Math.min(xPoints.length, yPoints.length));

                    if (numberOfPoints > 0) {
                        for (var i = 0; i < nPoints && i < numberOfPoints; i++) {
                            var x = _origin.x + xPoints[i];
                            var y = _origin.y + yPoints[i];

                            if (i === 0) {
                                _context.moveTo(x, y);
                            } else {
                                _context.lineTo(x, y);
                            }
                        }
                    }
                }
            }

            /**
            * Draws the text given by the specified string, using this graphics context''s current font and color
            * @param {String} str the string to be drawn
            * @param {Number} x  the x coordinate of the rectangle to intersect the clip with
            * @param {Number} y  the y coordinate of the rectangle to intersect the clip with
            * @param {Number} maxWidth  Optional; the maximum width to draw
            */
            this.drawString = function (str, x, y, maxWidth) {
                if (_context.fillText) {
                    if (!!maxWidth) {
                        _context.fillText(str, x, y);
                    } else {
                        _context.fillText(str, x, y, maxWidth);
                    }
                }
            };
            
            /**
            * Draws the text given by the specified string, using this graphics context''s current font and color
            * @param {String} image  The specified image to be drawn. This method does nothing if img is null
            * @param {Number} x  the x coordinate
            * @param {Number} y  the y coordinate
            * @param {Number} width  the width of the rectangle
            * @param {Number} height  the height of the rectangle
            * @param {Number} sx  the x coordinate of the first corner of the source rectangle
            * @param {Number} sy  the y coordinate of the first corner of the source rectangle
            * @param {Number} sWidth  the width of the source rectangle
            * @param {Number} sHeight  the height of the source rectangle
            */
            this.drawImage = function (image, x, y, width, height, sx, sy, sWidth, sHeight) {
                if (image) {
                    var imgObject = null;
                    if (typeof(image) === "string") {
                        imgObject = new Image();
                        imgObject.src = image;
                    } else {
                       imgObject = image;
                    }
                    
                    if (sWidth && sHeight) {
                        _context.drawImage(imgObject, sx, sy, sWidth, sHeight, x, y, width, height);
                    } else if (width && height) {
                        _context.drawImage(imgObject, x, y, width, height);
                    } else {
                        _context.drawImage(imgObject, x, y);
                    }
                }
            };

            /**
            * Intersects the current clip with the specified rectangle
            * @param {Number} x  the x coordinate of the rectangle to intersect the clip with
            * @param {Number} y  the y coordinate of the rectangle to intersect the clip with
            * @param {Number} width  the width of the rectangle to intersect the clip with
            * @param {Number} height  the height of the rectangle to intersect the clip with
            */
            this.clipRect = function (x, y, width, height) {

            };

            /**
            * Fills the specified rectangle
            * @param {Number} x  the x coordinate of the rectangle to be filled
            * @param {Number} y   the y coordinate of the rectangle to be filled
            * @param {Number} width  the width of the rectangle to be filled
            * @param {Number} height  the height of the rectangle to be filled
            */
            this.fillRect = function (x, y, width, height) {
                _context.fillRect(_origin.x + x, _origin.y + y, width, height);
            };

            /**
            * Clears the specified rectangle by filling it with the background color of the current drawing surface
            * @param {Number} x  the x coordinate of the rectangle to clear
            * @param {Number} y   the y coordinate of the rectangle to clear
            * @param {Number} width  the width of the rectangle to clear
            * @param {Number} height  the height of the rectangle to clear
            */
            this.clearRect = function (x, y, width, height) {
                _context.clearRect(x, y, width, height);
            };

            /**
            * Clears the specified rectangle by filling it with the background color of the current drawing surface
            * @param {Number} x  the x coordinate of the rectangle to clear
            * @param {Number} y   the y coordinate of the rectangle to clear
            * @param {Number} width  the width of the rectangle to clear
            * @param {Number} height  the height of the rectangle to clear
            */
            this.clear = function () {
                _context.clearRect(0, 0, this.getWidth(), this.getHeight());
            };

            /**
            * Draws the outline of the specified rectangle.
            * @param {Number} x  the x coordinate of the rectangle to be drawn
            * @param {Number} y   the y coordinate of the rectangle to be drawn
            * @param {Number} width  the width of the rectangle to be drawn
            * @param {Number} height  the height of the rectangle to be drawn
            */
            this.drawRect = function (x, y, width, height) {
                _context.strokeRect(_origin.x + x, _origin.y + y, width, height);
            };

            /**
            * Fills a circle bounded by the specified rectangle with the current color
            * @param {Number} x  the x coordinate of the upper left corner of the circle to be filled
            * @param {Number} y  the y coordinate of the upper left corner of the circle to be filled
            * @param {Number} radius  the radius of the circle to be filled
            */
            this.fillCircle = function (x, y, radius) {
                createCirclePath(x, y, radius);
                _context.fill();
            };

            /**
            * Draws the outline of a circle
            * @param {Number} x  the x coordinate of the upper left corner of the circle to be drawn
            * @param {Number} y  the y coordinate of the upper left corner of the circle to be drawn
            * @param {Number} radius  the radius of the circle to be drawn
            */
            this.drawCircle = function (x, y, radius) {
                createCirclePath(x, y, radius);
                _context.stroke();
            };

            /**
            * Fills a ellipse bounded by the specified rectangle with the current color
            * @param {Number} x  the x coordinate of the upper left corner of the circle to be filled
            * @param {Number} y  the y coordinate of the upper left corner of the circle to be filled
            * @param {Number} width  the width of the ellipse to be drawn
            * @param {Number} height  the height of the ellipse to be drawn
            */
            this.fillEllipse = function (x, y, width, height) {
                createEllipsePath(x, y, width, height);
                _context.fill();
            };

            /**
            * Draws the outline of a ellipse
            * @param {Number} x  the x coordinate of the upper left corner of the circle to be drawn
            * @param {Number} y  the y coordinate of the upper left corner of the circle to be drawn
            * @param {Number} radius  the radius of the circle to be drawn
            */
            this.drawEllipse = function (x, y, width, height) {
                createEllipsePath(x, y, width, height);
                _context.stroke();
            };

            /**
            * Draws a line, using the current color, between the points (x1, y1) and (x2, y2) in this graphics context''s coordinate system
            * @param {Number} x1  the first point''s x coordinate
            * @param {Number} y1  he first point''s y coordinate
            * @param {Number} x2  the second point''s x coordinate
            * @param {Number} y2  the second point''s y coordinate
            */
            this.drawLine = function (x1, y1, x2, y2) {
                _context.beginPath();
                _context.moveTo(_origin.x + x1, _origin.y + y1);
                _context.lineTo(_origin.x + x2, _origin.y + y2);
                _context.stroke();
            };

            /**
            * Draws a closed polygon defined by arrays of x and y coordinates
            * @param {Array} xPoints  an array of x coordinates
            * @param {Array} yPoints  an array of y coordinates
            * @param {Number} nPoints  the total number of points
            */
            this.drawPolygon = function (xPoints, yPoints, nPoints) {
                if ((nPoints > 0) && (xPoints !!== null) && (yPoints !!== null)) {
                    createPolygonPath(xPoints, yPoints, nPoints);
                    _context.stroke();
                }
            };

            /**
            * Fills a closed polygon defined by arrays of x and y coordinates
            * @param {Array} xPoints  an array of x coordinates
            * @param {Array} yPoints  an array of y coordinates
            * @param {Number} nPoints  the total number of points
            */
            this.fillPolygon = function (xPoints, yPoints, nPoints) {
                if ((nPoints > 0) && (xPoints !!== null) && (yPoints !!== null)) {
                    createPolygonPath(xPoints, yPoints, nPoints);
                    _context.fill();
                }
            };

            /**
            * Translates the origin of the graphics context to the point (x, y) in the current coordinate system
            * @param {Number} x  the x coordinate
            * @param {Number} y  the y coordinate
            */
            this.translate = function (x, y) {
                _origin.x = x;
                _origin.y = y;
            };
        }
    };

} ());'! !

!S2JWebApp methodsFor: 'rendering' stamp: 'sec 12/24/2010 20:01'!
javascriptClassEnvironmentCode

	^'Class = function(attributes)
{
var newClass = function() {};

if(''superClass'' in attributes) {
// copy superclass methods and attributes to new class
for(attr in attributes[''superClass'']) {
newClass.prototype[attr] = attributes[''superClass''][attr];
}

newClass.prototype.$superClass = attributes[''superClass''];
newClass.prototype.$super = function(method, args) {
return this.$superClass[method].apply(this, args);
};
}

if(''classVariables'' in attributes) {
// extent by new class variables
for(idx in attributes[''classVariables'']) {
newClass.prototype[attributes[''classVariables''][idx]] = null;
}
}

if(''classMethods'' in attributes) {
// extent by new class methods
for(method in attributes[''classMethods'']) {
newClass.prototype[method] = attributes[''classMethods''][method];
}
}

// initialize method is called after instanciation
newClass.prototype.$objectPrototype = function() { this.initialize(); };

newClass.prototype.new = function() {
// create new instance of our class
return new this.$objectPrototype();
}

if(''superClass'' in attributes) {
// inherit methods and attributes from superclass
newClass.prototype.$objectPrototype.prototype = attributes[''superClass''].new();
newClass.prototype.$objectPrototype.prototype.$superClass = attributes[''superClass''];

// ability to call superclass methods in the context of the current object
newClass.prototype.$objectPrototype.prototype.$super = function(method, args) {
return this.$superClass.$objectPrototype.prototype[method].apply(this, args);
};
}

if(''instanceVariables'' in attributes) {
// set instance variables to null by default
for(idx in attributes[''instanceVariables'']) {
newClass.prototype.$objectPrototype.prototype[attributes[''instanceVariables''][idx]] = null;
}
}

if(''instanceMethods'' in attributes) {
// extent by new instance methods
for(method in attributes[''instanceMethods'']) {
newClass.prototype.$objectPrototype.prototype[method] = attributes[''instanceMethods''][method];
}
}

newClass.prototype.$objectPrototype.prototype.class = new newClass();

return newClass.prototype.$objectPrototype.prototype.class;
};

JsGlobal = this;
Object$=Class({instanceMethods:{initialize: function(){}}});

// allow to use AnyClass.new() instead of new AnyClass(); where AnyClass is a function
Function.prototype.$new = function(){
	var obj = {};
	this.apply(obj, arguments);
	return obj;
};

'! !

!S2JWebApp methodsFor: 'rendering' stamp: 'LT 12/22/2010 16:07:45.22'!
javascriptCode

	^ '
	var data = null;
	var request = null;
	
	function createXmlRequest() {
		return new XMLHttpRequest();
	}
	
	function poll() {
		request = createXmlRequest();
		request.open("GET", "/xml", true);
		request.onreadystatechange = requestHandler;
		request.send(null);
	}
	
	function requestHandler() {
		if (request.readyState == 4) {
			if (request.status == 200) {
				var xml = request.responseXML.getElementsByTagName("data")[0].firstChild.data;
				log(request.status, decodeURIComponent(xml));
				poll();
			}
			else {
				log(request.status, null);
			}
		}
	}
	
	function send() {
		stop();
		data = document.getElementById("input").value;
		if (data !!= "") {
			request = createXmlRequest();
			request.open("POST", "/put", true);
			request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			request.onreadystatechange = responseHandler;
			request.send(encodeURIComponent(data));
		}
	}
	
	function responseHandler() {
		if ((request.readyState == 4) && (request.status == 201)) {
			log(201, data);
			poll();
		}
	}

	function stop() {
		if (request !!= null) {
			request.abort();
			request = null;
		}
	}
	
	function log(httpStatus, content) {
		if ((httpStatus == 200) || (httpStatus == 201)) {
			var evaluatedContent;
			try {
  				evaluatedContent = eval(content);
				prependRow("green", httpStatus, content, evaluatedContent);
			}
			catch(error) {
				prependRow("red", httpStatus, content, error);
			}
		}
		else if (httpStatus == 204) {
			prependRow("yellow", httpStatus, "No content", "");
		}
		else {
			prependRow("yellow", httpStatus, "Client aborted", "");
		} 
	}
		
	function prependRow(cssClass, httpStatus, logText, evalText) {
		var tbody = document.getElementsByTagName("tbody")[0];
		var firstRow = tbody.getElementsByTagName("tr")[0];
		var newRow = row(cssClass, httpStatus, logText, evalText);
		tbody.insertBefore(newRow, firstRow);
	}
	
	function row(cssClass, httpStatus, logText, evalText) {
		var row = document.createElement("tr");
		row.setAttribute("class", cssClass);
		var httpData = document.createElement("td");
		httpData.innerHTML = httpStatus;
		row.appendChild(httpData);
		var logData = document.createElement("td");
		logData.innerHTML = logText;
		row.appendChild(logData);
		var evalData = document.createElement("td");
		evalData.innerHTML = evalText;
		row.appendChild(evalData);
		return row;
	}
	
	function clearLog() {
		var tbody = document.getElementsByTagName("tbody")[0];
		while (tbody.childNodes.length > 0) {
			tbody.removeChild(tbody.childNodes[0]);
		}
	}'
	", ' function alert(a){ return a; } '"! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/6/2010 13:24'!
localResponseIdFor: aRequest

	^ self class sessions at: (aRequest cookie asNumber).! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/2/2010 10:50'!
postDataOf: aRequest

	aRequest isPostDataEmpty ifTrue: [ ^ nil ].
	^ aRequest postData keys any.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/2/2010 15:23'!
redirectToHome

	| response |
	response := HTTPResponse redirectLink.
	^ response
		location: self class applicationPath;
		yourself.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'LT 12/22/2010 16:23:40.534'!
renderBody

	^ '<body><div id="container">',
	self renderCanvas,
	self renderContent,
	'</div></body></html>'! !

!S2JWebApp methodsFor: 'rendering' stamp: 'LT 12/22/2010 17:07:04.002'!
renderCanvas

	^ '<canvas id="ballCanvas" width="400" height="300" style="background-color: #ffffff; border: solid 1px #000000;"></canvas>'! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/7/2010 11:34'!
renderContent

	^ '<h3>Post code</h3>
	<p><textarea id="input"></textarea></p>
	<p><input type="button" value="Send data" onclick="send();"></p>
	<h3>Log</h3>
	<p>
	<input type="button" value="Start polling" onclick="poll();">
	<input type="button" value="Stop polling" onclick="stop();">
	<input type="button" value="Clear log" onclick="clearLog();">
	</p>
	<table>
	<thead>
	<tr>
	<th>HTTP</th>
	<th>Log</th>
	<th>Eval</th>
	</tr>
	</thead>
	<tbody>
	</tbody>
	</table>
	</div>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'LT 12/22/2010 16:18:53.793'!
renderHeader

	^ self htmlDocumentType,
	'<html><head><title>',
	self class siteName,
	'</title>',
	'<script type="text/javascript">',
	self javascriptCode,
	'</script>',
	'<script type="text/javascript">',
	self javascriptCanvasLibraryCode,
	'</script>',
	'<script type="text/javascript">',
	self javascriptClassEnvironmentCode,
	'</script>',
	'<style type="text/css">',
	'<!!--',
	self cssData,
	'--></style></head>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/7/2010 10:47'!
renderWebsite

	^ self renderHeader,
	self renderBody.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/7/2010 11:04'!
startSessionWith: aResponse

	| randomId |
	[ randomId := 10e10 atRandom ] doWhileTrue:
		[ self class sessions includesKey: randomId ].
	self class sessions at: randomId put: self class defaultResponseId.
	aResponse cookie: randomId asString.
	
	Transcript show: 'Starting session #', randomId asString; cr.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 14:07'!
suspendRequestAndExecute: aBlock
	
	self class isServing ifFalse: [ ^ self answerNoContent ].
	
	self wait.	
	^ aBlock value.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 13:47'!
wait

	(Delay forMilliseconds: self class defaultMillisecondsToWait) wait.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 13:47'!
waitForMilliseconds: milliseconds

	(Delay forMilliseconds: milliseconds) wait.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/6/2010 15:12'!
withEncodedUriComponents: contentString

	| temporaryString |
	temporaryString := contentString.
	
	self class replacementDictionary keysAndValuesDo:
		[ :key :value |
			temporaryString := temporaryString copyReplaceAll: key with: value ].

	^ temporaryString.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/2/2010 18:53'!
wrapUpAsXml: content

	^ self xmlDocumentType, '<data>', (self withEncodedUriComponents: content), '</data>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/2/2010 00:16'!
xmlDocumentType

	^ '<?xml version="1.0"?>'.
! !
